let
  fromEnv = var: def:
    let val = builtins.getEnv var; in
    if val != "" then val else def;
in rec {
  perl = "/nix/store/xcp6lrq3ynj75cqcyy7b32jgizf9jr4b-perl-5.22.2/bin/perl";
  shell = "/nix/store/nyj6xd7s1n1w8c0xdwk5ddhi7bjcyi9x-bash-4.3-p46/bin/bash";
  coreutils = "/nix/store/zhhb02yrp03xzfrpk06ixb0gmwrjmjff-coreutils-8.25/bin";
  bzip2 = "/nix/store/df62wxiicpwkmbdbazgrs5d7i11473j8-bzip2-1.0.6.0.1-bin/bin/bzip2";
  gzip = "/nix/store/grz1v2hg0spjxxr3055f6kaa4irkr499-gzip-1.8/bin/gzip";
  xz = "/nix/store/ps4vswwmmasqffpxrd1rj68xrs9kw63h-xz-5.2.2-bin/bin/xz";
  tar = "/nix/store/blzs121zpxzms8axnblp1pbbzphrsb2r-gnutar-1.29/bin/tar";
  tarFlags = "--warning=no-timestamp";
  tr = "/nix/store/zhhb02yrp03xzfrpk06ixb0gmwrjmjff-coreutils-8.25/bin/tr";
  nixBinDir = fromEnv "NIX_BIN_DIR" "/nix/store/i4mwf2gpvar7dqvlpp5m86llbq3ahbvb-nix-1.11.4/bin";
  nixPrefix = "/nix/store/i4mwf2gpvar7dqvlpp5m86llbq3ahbvb-nix-1.11.4";

  # If Nix is installed in the Nix store, then automatically add it as
  # a dependency to the core packages. This ensures that they work
  # properly in a chroot.
  chrootDeps =
    if dirOf nixPrefix == builtins.storeDir then
      [ (builtins.storePath nixPrefix) ]
    else
      [ ];
}
